<?php

namespace SuperRhino\AppStoreServerApi;

use SuperRhino\AppStoreServerApi\Response\ServerNotificationsPayload;

class AppStoreServerNotifications {

    /**
     * Handle server notifications
     * @param string $signedPayload
     * @param string $applePemString
     * @return ServerNotificationsPayload
     */
    public function serverNotify(string $signedPayload, string $applePemString): ServerNotificationsPayload {
        $signedPayload = Util::decodeJWS($signedPayload, $applePemString);
        $signedPayload->data->signedTransactionInfo = Util::unsafeDecodeJWS($signedPayload->data->signedTransactionInfo);
        if ($signedRenewalInfo = $signedPayload->data->signedRenewalInfo ?? null) {
            $signedPayload->data->signedRenewalInfo = Util::unsafeDecodeJWS($signedRenewalInfo);
        }
        return ServerNotificationsPayload::make(json_decode(json_encode($signedPayload), true));
    }

}